<?php
namespace Vtb\VtbPay\Gateway\Http\Client;

class Api
{
    public function sendRequest(
        $url,
        $data = [],
        $headers = [],
        $method = 'POST',
        $jsonEncode = true
    ) {
        $curl = curl_init();
        
        if (in_array('Content-Type: application/json', $headers) && $jsonEncode) {
            $data = json_encode($data);
        }

        if ($method === 'POST') {
            curl_setopt($curl, CURLOPT_POST, 1);
            curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
        } 
        elseif ($method === 'PUT') {
            curl_setopt($curl, CURLOPT_CUSTOMREQUEST, 'PUT');
            curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
        } 
        else {
            $url .= is_array($data) ? '?' . http_build_query($data) : '';
        }

        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);

        $result = curl_exec($curl);
        
        if ($result === false) {
            throw new \Exception('Curl error: ' . curl_error($curl));
        }
        
        if (empty($result)) {
            throw new \Exception('The curl request returned an empty response');
        }
        
        $result = json_decode($result, true);
        
        if (json_last_error() != JSON_ERROR_NONE) {
            throw new \Exception('Json decode error: ' . json_last_error_msg());
        }

        curl_close($curl);

        return $result;
    }
}